diff --git a/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
similarity index 70%
rename from src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
index 38dfb7b99..7e00eb25b 100644
--- a/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
@@ -1,25 +1,25 @@
 package net.minecraft.core.block.entity;
 
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.NoteBlock;
+import net.minecraft.core.block.BlockNote;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.util.helper.MathHelper;
 
 @Deprecated
-public class NoteBlockEntity extends BlockEntity
+public class TileEntityNoteblock extends TileEntity
 {
 
 
     public byte note;
 
-    public NoteBlockEntity() {
+    public TileEntityNoteblock() {
         note = 0;
     }
 
     @Override
     public void tick() {
         if (worldObj.getBlock(x, y, z) == Blocks.NOTEBLOCK) { // Set note block pitch
-            worldObj.setBlockMetadata(x, y, z, NoteBlock.setNote(0, note));
+            worldObj.setBlockMetadata(x, y, z, BlockNote.setNote(0, note));
         }
         invalidate(); // Delete self
     }
@@ -33,7 +33,7 @@ public class NoteBlockEntity extends BlockEntity
     @Override
 	public void readFromNBT(CompoundTag tag) {
         super.readFromNBT(tag);
-        note = MathHelper.clamp(tag.getByte("note"), (byte) 0, NoteBlock.MAX_NOTE);
+        note = MathHelper.clamp(tag.getByte("note"), (byte) 0, BlockNote.MAX_NOTE);
     }
 
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
index 30727fdd7..9152d4e2c 100644
--- a/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
@@ -3,22 +3,21 @@ package net.minecraft.core.block.entity;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import com.mojang.nbt.CompoundTag;
 
-public class SeatBlockEntity
-    extends BlockEntity
+public class TileEntitySeat
+    extends TileEntity
     implements IVehicle {
     private Entity passenger;
 
     public Block seat;
-    public SeatBlockEntity() {
+    public TileEntitySeat() {
         this(null);
     }
-    public SeatBlockEntity(Block seat) {
+    public TileEntitySeat(Block seat) {
         passenger = null;
         this.seat = seat;
     }
diff --git a/src/main/java/net/minecraft/core/block/entity/SensorBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/entity/SensorBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
index ac2d70083..88e5f0514 100644
--- a/src/main/java/net/minecraft/core/block/entity/SensorBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
@@ -5,7 +5,7 @@ import java.util.List;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.MotionSensorBlock;
+import net.minecraft.core.block.BlockMotionSensor;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
@@ -15,7 +15,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
-public class SensorBlockEntity extends BlockEntity {
+public class TileEntitySensor extends TileEntity {
 
 	private int getSightRange(World world, double x, double y, double z, Direction facing) {
 		if(facing == Direction.NONE) {
@@ -71,7 +71,7 @@ public class SensorBlockEntity extends BlockEntity {
 		int meta = worldObj.getBlockMetadata(x, y, z);
 		
 		boolean shouldBeActive = false;
-		Direction facing = MotionSensorBlock.getFacingDirection(meta);
+		Direction facing = BlockMotionSensor.getFacingDirection(meta);
 		int effectiveRange = getSightRange(worldObj, x, y, z, facing);
 		if(effectiveRange > 0) {
 			AABB detectionBox = getDetectionBox(x, y, z, facing, effectiveRange);
@@ -106,7 +106,7 @@ public class SensorBlockEntity extends BlockEntity {
 		int meta = carriedBlock.metadata;
 
 		boolean shouldBeActive = false;
-		Direction facing = MotionSensorBlock.getFacingDirection(meta);
+		Direction facing = BlockMotionSensor.getFacingDirection(meta);
 		int effectiveRange = getSightRange(world, holder.x, holder.y, holder.z, facing);
 		if(effectiveRange > 0) {
 			AABB detectionBox = getDetectionBox(holder.x, holder.y, holder.z, facing, effectiveRange);
diff --git a/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
index 46bc1c4c0..033b6e71e 100644
--- a/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
@@ -1,19 +1,17 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.BlockEntityDataPacket;
 import net.minecraft.core.util.helper.UUIDHelper;
-import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.UUID;
 
-public class SignBlockEntity extends BlockEntity
+public class TileEntitySign extends TileEntity
 {
     public static final int MAX_LINE_SIZE = 15;
     public String[] signText = { "", "", "", "" };
@@ -23,7 +21,7 @@ public class SignBlockEntity extends BlockEntity
     private @Nullable UUID owner;
     private boolean glowing = false;
 
-    public SignBlockEntity()
+    public TileEntitySign()
     {
         lineBeingEdited = -1;
     }
diff --git a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
similarity index 93%
rename from src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
rename to src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index 4d3f94909..fee933a60 100644
--- a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -6,16 +6,16 @@ import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.ChestBlock;
-import net.minecraft.core.block.TrommelBlock;
+import net.minecraft.core.block.BlockChest;
+import net.minecraft.core.block.BlockTrommel;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
-import net.minecraft.core.entity.monster.SlimeMob;
+import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.monster.MobSlime;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
@@ -29,14 +29,13 @@ import org.slf4j.Logger;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
-import java.util.Objects;
 import java.util.Random;
 
-public class TrommelBlockEntity extends BlockEntity
+public class TileEntityTrommel extends TileEntity
         implements Container
 {
 
-    public TrommelBlockEntity()
+    public TileEntityTrommel()
     {
         itemStacks = new ItemStack[5];
         burnTime = 0;
@@ -187,7 +186,7 @@ public class TrommelBlockEntity extends BlockEntity
             			itemStacks[4].stackSize--;
             			if(itemStacks[4].stackSize <= 0) itemStacks[4] = null;
             			if (worldObj != null) {
-                            TrommelBlock.updateTrommelBlockState(true, worldObj, x, y, z);
+                            BlockTrommel.updateTrommelBlockState(true, worldObj, x, y, z);
                         } else if (carriedBlock != null) {
                             carriedBlock.blockId = Blocks.TROMMEL_ACTIVE.id;
                         }
@@ -235,7 +234,7 @@ public class TrommelBlockEntity extends BlockEntity
             {
                 flag1 = true;
                 if (worldObj != null) {
-                    TrommelBlock.updateTrommelBlockState(burnTime > 0, worldObj, x, y, z);
+                    BlockTrommel.updateTrommelBlockState(burnTime > 0, worldObj, x, y, z);
                 } else if (carriedBlock != null) {
                     carriedBlock.blockId = burnTime > 0 ? Blocks.TROMMEL_ACTIVE.id : Blocks.TROMMEL_IDLE.id;
                 }
@@ -292,9 +291,9 @@ public class TrommelBlockEntity extends BlockEntity
         	int adjacentId = worldObj != null ? worldObj.getBlockId(x + xOffset, y, z + zOffset) : 0;
         	
         	Container chest = null;
-        	if (Block.blocksList[adjacentId] instanceof ChestBlock) {
+        	if (Block.blocksList[adjacentId] instanceof BlockChest) {
                 assert worldObj != null;
-                chest = ChestBlock.getInventory(worldObj, x + xOffset, y, z + zOffset);
+                chest = BlockChest.getInventory(worldObj, x + xOffset, y, z + zOffset);
         	}
         	
         	if (chest != null)
@@ -337,18 +336,18 @@ public class TrommelBlockEntity extends BlockEntity
 
             float f = (((float) 1 - 0.5F)) / 4F;
             float f1 = (((float) 1 - 0.5F)) / 4F;
-            SlimeMob slimeMob = new SlimeMob(carriedBlock != null ? carriedBlock.world : worldObj);
-            slimeMob.setSlimeSize(1);
+            MobSlime mobSlime = new MobSlime(carriedBlock != null ? carriedBlock.world : worldObj);
+            mobSlime.setSlimeSize(1);
             float f3 = 0.05F;
-            slimeMob.xd = (float) random.nextGaussian() * f3;
-            slimeMob.yd = (float) random.nextGaussian() * f3 + 0.2F;
-            slimeMob.zd = (float) random.nextGaussian() * f3;
+            mobSlime.xd = (float) random.nextGaussian() * f3;
+            mobSlime.yd = (float) random.nextGaussian() * f3 + 0.2F;
+            mobSlime.zd = (float) random.nextGaussian() * f3;
             if (worldObj != null) {
-                slimeMob.moveTo(x + (double)f, y + 1D, z + (double)f1, random.nextFloat() * 360F, 0.0F);
-                worldObj.entityJoinedWorld(slimeMob);
+                mobSlime.moveTo(x + (double)f, y + 1D, z + (double)f1, random.nextFloat() * 360F, 0.0F);
+                worldObj.entityJoinedWorld(mobSlime);
             } else if (carriedBlock != null) {
-                slimeMob.moveTo(carriedBlock.holder.x + (double)f, carriedBlock.holder.y + carriedBlock.holder.heightOffset, carriedBlock.holder.z + (double)f1, random.nextFloat() * 360F, 0.0F);
-                carriedBlock.world.entityJoinedWorld(slimeMob);
+                mobSlime.moveTo(carriedBlock.holder.x + (double)f, carriedBlock.holder.y + carriedBlock.holder.heightOffset, carriedBlock.holder.z + (double)f1, random.nextFloat() * 360F, 0.0F);
+                carriedBlock.world.entityJoinedWorld(mobSlime);
             }
         }
     }
@@ -406,7 +405,7 @@ public class TrommelBlockEntity extends BlockEntity
     @Override
     public void dropContents(World world, int x, int y, int z) {
         super.dropContents(world, x, y, z);
-        if (!TrommelBlock.keepTrommelInventory)
+        if (!BlockTrommel.keepTrommelInventory)
         {
             if(world.getBlockEntity(x, y, z) != null)
             {
@@ -429,7 +428,7 @@ public class TrommelBlockEntity extends BlockEntity
                             i1 = itemstack.stackSize;
                         }
                         itemstack.stackSize -= i1;
-                        ItemEntity item = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                        EntityItem item = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
                         float f3 = 0.05F;
                         item.xd = (float) random.nextGaussian() * f3;
                         item.yd = (float) random.nextGaussian() * f3 + 0.2F;
@@ -514,7 +513,7 @@ public class TrommelBlockEntity extends BlockEntity
 
 //        DataLoader.loadDataPacks(this);
 
-        TrommelBlockEntity trommel = new TrommelBlockEntity();
+        TileEntityTrommel trommel = new TileEntityTrommel();
         trommel.worldObj = new World();
 
         trommel.simulateTrommelDrops(10000, Blocks.DIRT.getDefaultStack());
diff --git a/src/main/java/net/minecraft/core/block/material/Material.java b/src/main/java/net/minecraft/core/block/material/Material.java
index 8bb721e26..69e27c55f 100644
--- a/src/main/java/net/minecraft/core/block/material/Material.java
+++ b/src/main/java/net/minecraft/core/block/material/Material.java
@@ -139,7 +139,7 @@ public class Material
     }
 
 
-    public static final Material air = new GasMaterial(MaterialColor.none);
+    public static final Material air = new MaterialGas(MaterialColor.none);
     public static final Material grass = new Material(MaterialColor.grass);
     public static final Material dirt = new Material(MaterialColor.dirt);
     public static final Material wood = new Material(MaterialColor.wood).flammable();
@@ -155,26 +155,26 @@ public class Material
 
     public static final Material metal = new Material(MaterialColor.metal).setConductivity(LIGHTNING_STRONG_CONDUCTOR).setAsMetal().notAlwaysDestroyable();
     public static final Material steel = new Material(MaterialColor.steel).setConductivity(LIGHTNING_STRONG_CONDUCTOR).setAsMetal().notAlwaysDestroyable();
-    public static final Material water = new LiquidMaterial(MaterialColor.water).setConductivity(LIGHTNING_LIGHT_CONDUCTOR).destroyOnPush();
-    public static final Material lava = new LiquidMaterial(MaterialColor.fire).destroyOnPush();
+    public static final Material water = new MaterialLiquid(MaterialColor.water).setConductivity(LIGHTNING_LIGHT_CONDUCTOR).destroyOnPush();
+    public static final Material lava = new MaterialLiquid(MaterialColor.fire).destroyOnPush();
     public static final Material leaves = new Material(MaterialColor.plant).flammable().notSolidBlocking().destroyOnPush();
-    public static final Material plant = new DecorationMaterial(MaterialColor.plant).destroyOnPush().replaceable();
+    public static final Material plant = new MaterialDecoration(MaterialColor.plant).destroyOnPush().replaceable();
     public static final Material sponge = new Material(MaterialColor.wool);
     public static final Material cloth = new Material(MaterialColor.wool).flammable();
-    public static final Material fire = new GasMaterial(MaterialColor.none).destroyOnPush();
+    public static final Material fire = new MaterialGas(MaterialColor.none).destroyOnPush();
     public static final Material sand = new Material(MaterialColor.sand);
     public static final Material soulsand = new Material(MaterialColor.paintedBrown);
-    public static final Material decoration = new DecorationMaterial(MaterialColor.none).destroyOnPush();
+    public static final Material decoration = new MaterialDecoration(MaterialColor.none).destroyOnPush();
     public static final Material glass = new Material(MaterialColor.none).setConductivity(LIGHTNING_STRONG_INSULATOR).notSolidBlocking();
     public static final Material explosive = new Material(MaterialColor.fire).flammable().notSolidBlocking();
     public static final Material coral = new Material(MaterialColor.plant).destroyOnPush();
     public static final Material ice = new Material(MaterialColor.ice).notSolidBlocking();
-    public static final Material topSnow = new DecorationMaterial(MaterialColor.snow).replaceable().notSolidBlocking().notAlwaysDestroyable().destroyOnPush();
+    public static final Material topSnow = new MaterialDecoration(MaterialColor.snow).replaceable().notSolidBlocking().notAlwaysDestroyable().destroyOnPush();
     public static final Material snow = new Material(MaterialColor.snow).notAlwaysDestroyable();
     public static final Material cactus = new Material(MaterialColor.plant).notSolidBlocking().destroyOnPush();
     public static final Material clay = new Material(MaterialColor.clay);
     public static final Material vegetable = new Material(MaterialColor.plant).destroyOnPush();
-    public static final Material portal = new PortalMaterial(MaterialColor.none).notPushable();
+    public static final Material portal = new MaterialPortal(MaterialColor.none).notPushable();
     public static final Material cake = new Material(MaterialColor.none).destroyOnPush();
     public static final Material web = new Material(MaterialColor.wool).notAlwaysDestroyable().destroyOnPush();
     public static final Material piston = new Material(MaterialColor.stone);
diff --git a/src/main/java/net/minecraft/core/block/material/DecorationMaterial.java b/src/main/java/net/minecraft/core/block/material/MaterialDecoration.java
similarity index 79%
rename from src/main/java/net/minecraft/core/block/material/DecorationMaterial.java
rename to src/main/java/net/minecraft/core/block/material/MaterialDecoration.java
index 541222963..cff0d9a52 100644
--- a/src/main/java/net/minecraft/core/block/material/DecorationMaterial.java
+++ b/src/main/java/net/minecraft/core/block/material/MaterialDecoration.java
@@ -4,10 +4,10 @@ package net.minecraft.core.block.material;
 // Referenced classes of package net.minecraft.src:
 //            Material, MapColor
 
-public class DecorationMaterial extends Material
+public class MaterialDecoration extends Material
 {
 
-    public DecorationMaterial(MaterialColor mapcolor)
+    public MaterialDecoration(MaterialColor mapcolor)
     {
         super(mapcolor);
     }
diff --git a/src/main/java/net/minecraft/core/block/material/GasMaterial.java b/src/main/java/net/minecraft/core/block/material/MaterialGas.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/material/GasMaterial.java
rename to src/main/java/net/minecraft/core/block/material/MaterialGas.java
index ef2a6399a..3efb73a86 100644
--- a/src/main/java/net/minecraft/core/block/material/GasMaterial.java
+++ b/src/main/java/net/minecraft/core/block/material/MaterialGas.java
@@ -4,10 +4,10 @@ package net.minecraft.core.block.material;
 // Referenced classes of package net.minecraft.src:
 //            Material, MapColor
 
-public class GasMaterial extends Material
+public class MaterialGas extends Material
 {
 
-    public GasMaterial(MaterialColor mapcolor)
+    public MaterialGas(MaterialColor mapcolor)
     {
         super(mapcolor);
         replaceable();
diff --git a/src/main/java/net/minecraft/core/block/material/LiquidMaterial.java b/src/main/java/net/minecraft/core/block/material/MaterialLiquid.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/material/LiquidMaterial.java
rename to src/main/java/net/minecraft/core/block/material/MaterialLiquid.java
index 6a3eb4c19..144a11813 100644
--- a/src/main/java/net/minecraft/core/block/material/LiquidMaterial.java
+++ b/src/main/java/net/minecraft/core/block/material/MaterialLiquid.java
@@ -4,10 +4,10 @@ package net.minecraft.core.block.material;
 // Referenced classes of package net.minecraft.src:
 //            Material, MapColor
 
-public class LiquidMaterial extends Material
+public class MaterialLiquid extends Material
 {
 
-    public LiquidMaterial(MaterialColor mapcolor)
+    public MaterialLiquid(MaterialColor mapcolor)
     {
         super(mapcolor);
         replaceable();
diff --git a/src/main/java/net/minecraft/core/block/material/PortalMaterial.java b/src/main/java/net/minecraft/core/block/material/MaterialPortal.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/material/PortalMaterial.java
rename to src/main/java/net/minecraft/core/block/material/MaterialPortal.java
index 071f17b88..8d2c8a165 100644
--- a/src/main/java/net/minecraft/core/block/material/PortalMaterial.java
+++ b/src/main/java/net/minecraft/core/block/material/MaterialPortal.java
@@ -4,10 +4,10 @@ package net.minecraft.core.block.material;
 // Referenced classes of package net.minecraft.src:
 //            Material, MapColor
 
-public class PortalMaterial extends Material
+public class MaterialPortal extends Material
 {
 
-    public PortalMaterial(MaterialColor mapcolor)
+    public MaterialPortal(MaterialColor mapcolor)
     {
         super(mapcolor);
     }
diff --git a/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java b/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
index 4825e7d17..9764603a4 100644
--- a/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
+++ b/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
@@ -2,8 +2,8 @@ package net.minecraft.core.block.motion;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.BlockEntityDispatcher;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
@@ -18,24 +18,27 @@ import org.jetbrains.annotations.Nullable;
 public class CarriedBlock implements ICarriable {
     public int blockId;
     public int metadata;
-    public @Nullable BlockEntity entity;
+    public @Nullable TileEntity entity;
     // Ignore warnings, nbt read process *should* guarantee these to be non-null
     public @NotNull Entity holder;
     public @NotNull World world;
-    public CarriedBlock(@NotNull Entity holder, @NotNull Block block, int metadata, @Nullable BlockEntity entity) {
+    public CarriedBlock(@NotNull Entity holder, @NotNull Block block, int metadata, @Nullable TileEntity entity) {
         this(holder, block.id, metadata, entity);
     }
 
-    public CarriedBlock(@NotNull Entity holder, int blockId, int metadata, @Nullable BlockEntity entity) {
+    public CarriedBlock(@NotNull Entity holder, int blockId, int metadata, @Nullable TileEntity entity) {
         this.holder = holder;
         this.blockId = blockId;
         this.metadata = metadata;
         this.entity = entity;
         this.world = holder.world;
+        assert world != null : "Carried block world ref must not be null!";
     }
 
-    protected CarriedBlock() {
-
+    protected CarriedBlock(@NotNull Entity holder) {
+        this.holder = holder;
+        this.world = holder.world;
+        assert world != null : "Carried block world ref must not be null!";
     }
 
     public Block block() {
@@ -117,7 +120,7 @@ public class CarriedBlock implements ICarriable {
     @Override
     public void readFromNBT(CompoundTag tag) {
         if (tag.containsKey("entity")) {
-            entity = BlockEntityDispatcher.createAndLoadEntity(tag.getCompound("entity"));
+            entity = TileEntityDispatcher.createAndLoadEntity(tag.getCompound("entity"));
             if (entity != null) {
                 entity.carriedBlock = this;
             }
@@ -127,8 +130,7 @@ public class CarriedBlock implements ICarriable {
     }
 
     public static CarriedBlock createAndLoadCarriedBlock(@NotNull Entity holder, CompoundTag tag) {
-        CarriedBlock carriedBlock = new CarriedBlock();
-        carriedBlock.holder = holder;
+        CarriedBlock carriedBlock = new CarriedBlock(holder);
         carriedBlock.readFromNBT(tag);
         return carriedBlock;
     }
diff --git a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
similarity index 90%
rename from src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
rename to src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
index 5be57f85e..9a5d59bb6 100644
--- a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
@@ -2,10 +2,9 @@ package net.minecraft.core.block.piston;
 
 import java.util.ArrayList;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Mob;
@@ -22,7 +21,7 @@ import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class PistonBaseBlock extends Block
+public class BlockPistonBase extends Block
 {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int MASK_POWERED = 0b0000_1000;
@@ -32,7 +31,7 @@ public class PistonBaseBlock extends Block
 
     private final int maxPushedBlocks;
 
-    public PistonBaseBlock(String key, String namespaceId, int id, int maxPushedBlocks)
+    public BlockPistonBase(String key, String namespaceId, int id, int maxPushedBlocks)
     {
         super(key, namespaceId, id, Material.piston);
         this.maxPushedBlocks = maxPushedBlocks;
@@ -166,18 +165,18 @@ public class PistonBaseBlock extends Block
     }
 
     public void retractEvent(World world, int x, int y, int z, int data, Direction direction) {
-        BlockEntity blockEntity = world.getBlockEntity(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
-        if((blockEntity instanceof MovingPistonBlockEntity))
+        TileEntity tileEntity = world.getBlockEntity(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
+        if((tileEntity instanceof TileEntityMovingPistonBlock))
         {
-            MovingPistonBlockEntity moving = ((MovingPistonBlockEntity) blockEntity);
+            TileEntityMovingPistonBlock moving = ((TileEntityMovingPistonBlock) tileEntity);
             if (!moving.isExtending()) {
-                ((MovingPistonBlockEntity)blockEntity).finalTick();
+                ((TileEntityMovingPistonBlock) tileEntity).finalTick();
             } else {
                 world.setBlock(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), 0);
             }
         }
         world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, direction.getId());
-        world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(id, direction.getId(), null, direction, false, true));
+        world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(id, direction.getId(), null, direction, false, true));
         world.setBlockWithNotify(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), 0);
         world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
     }
@@ -348,8 +347,8 @@ public class PistonBaseBlock extends Block
             int pz = zo - direction.getOffsetZ();
             int pushId = world.getBlockId(px, py, pz);
             int pushMeta = world.getBlockMetadata(px, py, pz);
-            BlockEntity pushEntity = world.getBlockEntity(px, py, pz);
-            if (pushEntity instanceof MovingPistonBlockEntity && px == x && py == y && pz == z) {
+            TileEntity pushEntity = world.getBlockEntity(px, py, pz);
+            if (pushEntity instanceof TileEntityMovingPistonBlock && px == x && py == y && pz == z) {
                 break;
             }
             if(pushId == id && px == x && py == y && pz == z)
@@ -357,9 +356,9 @@ public class PistonBaseBlock extends Block
                 createPistonHeadAt(world, xo, yo, zo, data, direction);
             } else if (pushId == Blocks.PISTON_MOVING.id)
             {
-                BlockEntity old = world.getBlockEntity(px, py, pz);
-                if (old instanceof MovingPistonBlockEntity) {
-                    MovingPistonBlockEntity moving = (MovingPistonBlockEntity) old;
+                TileEntity old = world.getBlockEntity(px, py, pz);
+                if (old instanceof TileEntityMovingPistonBlock) {
+                    TileEntityMovingPistonBlock moving = (TileEntityMovingPistonBlock) old;
                     if (!moving.isSourcePiston()) {
                         pushId = moving.getMovedId();
                         pushMeta = moving.getMovedData();
@@ -368,12 +367,12 @@ public class PistonBaseBlock extends Block
                 }
                 world.removeBlockTileEntity(px, py, pz);
                 world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id, pushMeta);
-                world.replaceBlockTileEntity(xo, yo, zo, MovingPistonBlock.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
+                world.replaceBlockTileEntity(xo, yo, zo, BlockPistonMoving.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
             } else
             {
                 world.removeBlockTileEntity(px, py, pz);
                 world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id, pushMeta);
-                world.replaceBlockTileEntity(xo, yo, zo, MovingPistonBlock.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
+                world.replaceBlockTileEntity(xo, yo, zo, BlockPistonMoving.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
             }
             if (!(px == x && py == y && pz == z))
                 world.setBlockAndMetadataRaw(px, py, pz, 0, 0);
@@ -386,8 +385,8 @@ public class PistonBaseBlock extends Block
     }
 
     public void createPistonHeadAt(World world, int x, int y, int z, int data, Direction direction) {
-        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_NORMAL, direction.getId()));
-        world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(Blocks.PISTON_HEAD.id, PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_NORMAL, direction.getId()), null, direction, true, false));
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, BlockPistonHead.setPistonType(BlockPistonHead.TYPE_NORMAL, direction.getId()));
+        world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(Blocks.PISTON_HEAD.id, BlockPistonHead.setPistonType(BlockPistonHead.TYPE_NORMAL, direction.getId()), null, direction, true, false));
     }
     
     @Override
